/* (C) 2016 Yana */

module hlscore (
	input ap_clk,
	input ap_rst,
	input ap_start,
	output reg ap_done,
	output reg ap_idle,
	output reg ap_ready,
	input [7:0] reset,
	input [7:0] c,
	output reg [7:0] ap_return
);

reg state;

parameter SIZE = 5;
wire [7:0] string[0:SIZE-1];
assign string[0] = "(";
assign string[1] = "H";
assign string[2] = "D";
assign string[3] = "L";
assign string[4] = ")";
reg [2:0] i;

always @(posedge ap_clk, posedge ap_rst) begin
	if (ap_rst) begin
		ap_done <= 0;
		ap_idle <= 1;
		ap_ready <= 0;
		state <= 0;
		i <= 0;
	end else begin
		case (state)
			0: begin
				if (!ap_start) begin
					ap_idle <= 1;
				end else begin
					ap_done <= 1;
					ap_idle <= 0;
					ap_ready <= 1;
					if (reset) begin
						ap_return <= 0;
						i <= 0;
					end else begin
						if (i < SIZE) begin
							ap_return <= string[i];
							i <= i + 1;
						end else begin
							ap_return <= c;
						end
					end
					state <= 1;
				end
			end
			1: begin
				ap_done <= 0;
				ap_ready <= 0;
				state <= 0;
			end
		endcase
	end
end

endmodule
